#include "sorted_array_list.h"

template <typename T>
bool SortedArrayList<T>::isEmpty()
{
  return plist.isEmpty();
}

template <typename T>
std::size_t SortedArrayList<T>::getLength()
{
  return plist.getLength();
}

template <typename T>
void SortedArrayList<T>::insert(const T& item)
{
  std::size_t pos = 0;
  while(pos < plist.getLength()){
    if(plist.getEntry(pos) > item) break;
    ++pos;
  }
  plist.insert(pos, item);
}

template <typename T>
void SortedArrayList<T>::remove(const T& item)
{
  if(isEmpty()) throw std::range_error("empty list in remove");
  
  std::size_t pos = 0;
  while(pos < plist.getLength()){
    if(plist.getEntry(pos) == item) break;
    ++pos;
  }
  if(pos < plist.getLength()){
    plist.remove(pos);
  }
}

template <typename T>
void SortedArrayList<T>::removeAt(std::size_t position)
{
  plist.remove(position);
}

template <typename T>
void SortedArrayList<T>::clear()
{
  plist.clear();
}

template <typename T>
T SortedArrayList<T>::getEntry(std::size_t position)
{
  return plist.getEntry(position);
}

template <typename T>
long int SortedArrayList<T>::getPosition(const T& newValue)
{
  bool found = false;
  long int pos = 0;
  while(pos < plist.getLength()){
    if(plist.getEntry(pos) == newValue) found = true;
    if(plist.getEntry(pos) > newValue) break;
    ++pos;
  }
  if(!found){
    pos = -pos;
  }else{
    pos = (pos > 0) ? (pos-1) : 0;
  }
  
  return pos;
}
